/*****************************************************************************
 Gestionnaire de terminal Unix: clock.h  (c) Pierre Adriaans 1994
------------------------------------------------------------------------------
 Include de clock.c

 Petite librairie pour faciliter la gestion d'une horloge dans un programme:

  - doit etre utilisee conjointement avec la librairie de gestion de
    l'ecran screen.c
  - les parametres de fonctionnement et d'affichage sont communiques
    a la librairie lors de l'appel a la fonction InitClock()
  - l'heure est affichee et sera memorisee dans l'emulation de memoire
    video de l'unite screen (restons coherents)
  - deux types d'horloges:
     HOUR_MIN_SEC: horloge complete, ticks d'une seconde
     HOUR_MIN: horloge avec heure et minutes, ticks de 60 secondes
  - a l'initialisation, l'ancienne adresse de l'interruption d'horloge
    est sauvee ainsi que la valeur courante du reveil. Lors d'un appel
    a CancelClock(), ces deux valeurs sont retablies.
  - pour les raisons developpees dans keyboard.c, il est donc preferrable
    d'initialiser l'horloge APRES le clavier.
  - l'horloge peut etre momentanement interrompue (par CancelClock()), puis
    retablie sans qu'il soit besoin de recommuniquer les parametres
    (par ResumeClock()).
  - pour changer les parametres de fonctionnement proprement:
      - CancelClock()
      - InitClock() avec les nouveaux parametres
*****************************************************************************/

#ifndef _CLOCK_H_
#define _CLOCK_H_

#define HOUR_MIN_SEC  0
#define HOUR_MIN      1

void InitClock(int Lig,int Col,char Attr,int Type);
void CancelClock(void);
void ResumeClock(void);
void DisplayTime(void);

#endif
