/*****************************************************************************
 Gestionnaire de terminal Unix: inputbox.h  (c) Pierre Adriaans 1994
------------------------------------------------------------------------------
 Include de inputbox.c

 Fonctions d'entree de donnees avec possibilite de check box.

 Dans le cas ou aucun check box n'est necessaire: InputBox().
 - Cette fonction presente une simple boite de dialogue avec titre, message
   sur une ligne et saisie d'une chaine de caracteres
 - Les touches utilisables sont les memes que Gets(), mais sans la
   commutation de mode Insert/Overstrike (Tab utilise pour acceder aux Check
   boxes).
 - La saisie peut etre annulee par <ESC> ou confirmee par <Enter>
 - La fonction calcule elle-meme les coordonnees de la boite de facon a ce
   que celle-ci soit centree.
 - Parametres:
    - Buffer de saisie
    - Nbre Max de caracteres
    - Attribut de la boite
    - Attribut de la zone de saisie
    - Titre
    - Message
    - Decalage des lignes (positif pour plus bas, negatif pour plus haut)
    - Decalage des colonnes (positif pour plus a droite, negatif pour plus
      a gauche)
    - Type de cadre

 Dans le cas ou il faut un ou plusieurs check box: InputBoxCB()
 - Les caracteristiques de InputBox() sont d'application
 - Pour passer du buffer de saisie aus check box, voyager de gauche a
   droite dans ceux-ci et retourner au buffer de saisie: touche Tab
 - Pour changer la valeur (Booleenne, 0 ou 1) d'un check box, Space
 - La manipulation des check box se fait par les types et les fonctions
   definies dans checkbox.h
 - Parametres:
    - Buffer de saisie
    - Nbre Max de caracteres
    - Attribut de la boite
    - Attribut de la zone de saisie
    - Titre
    - Message
    - Pointeur de tete des intitules de check box
    - Tableau d'entier contenant les valeurs initiales des chack box
    - Decalage des lignes (positif pour plus bas, negatif pour plus haut)
    - Decalage des colonnes (positif pour plus a droite, negatif pour plus
      a gauche)
    - Type de cadre

 Code de retour:
  -1 si pas possible d'ouvrir la fenetre
   0 si saisie confirmee par <Enter>. La variable est initialisee.
   1 si saisie annulee par <ESC>. La variable est intacte.
*****************************************************************************/

#ifndef _INPUTBOX_H_
#define _INPUTBOX_H_

#include "checkbox.h"

int InputBox(char *Str,int MaxChar,char AttBox,char AttBuffer,
	     char *Title,char *Message,
	     int LigShift,int ColShift,int Frame);

int InputBoxCB(char *Str,int MaxChar,char AttBox,char AttBuffer,
	       char *Title,char *Message,
	       CheckBoxItem_t *CheckStr,int *CheckL,
	       int LigShift,int ColShift,int Frame);

#endif
