/*****************************************************************************
 Gestionnaire de terminal Unix: printf.h (c) Pierre Adriaans 1994
------------------------------------------------------------------------------
 Include de printf.c

 Fonction a nombre d'arguments variables fonctionnant exactement comme
 le printf() classique.

 - Cette fonction est la fonction d'affichage prevue pour travailler avec
   les unites screen et keyboard. 
 - Tous les formats supportes par printf() le sont par Printf().
 - La fonction effectue ses affichages dans la fenetre active courante
   en gerant les passages a la ligne et le scrolling.
 - Cette fonction est necessaire a un bon fonctionnement des fonctions
   de l'unite screen car elle maintient a jour l'emulation de memoire
   video de cette unite ansi que les variables maintenant la position du
   curseur.
 - Le formattage des arguments en '%' n'utilise pas le code de retour (int)
   de sprintf, car le sprintf de ULTRIX BSD 4.3 renvoie un (char *).
 - La fonction est line-buffered: les caracteres ne sont affiches qu'a
   l'emission d'un '\n' ou a l'appel de fflush(stdout).
*****************************************************************************/

#ifndef _PRINTF_H_
#define _PRINTF_H_

#include "screen.h"
#include "keyboard.h"
#include <stdarg.h>

#define PRINTF_BUF_SIZE 255 /* Taille du buffer de formattage */
#define PRINTF_TAB_SIZE 8   /* Nombre de ' ' pour un '\t' */

int Printf(char *Format,...);

#endif


